<?php

/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\OrderAdditionalData\Model;

use FiloBlu\OrderAdditionalData\Api\ProductOptionInterface;
use Magento\Catalog\Api\Data\ProductOptionExtensionInterface;
use Magento\Framework\DataObject;

/**
 * OAD Order Item Additional Data
 */
class ProductOption extends DataObject implements ProductOptionInterface
{
    /**
     * @return string|null
     */
    public function getLabel()
    {
        return $this->getData('label');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setLabel($data)
    {
        return $this->setData('label', $data);
    }

    /**
     * @return string|null
     */
    public function getValue()
    {
        return $this->getData('value');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setValue($data)
    {
        return $this->setData('value', $data);
    }

    /**
     * @return string|null
     */
    public function getPrintValue()
    {
        return $this->getData('print_value');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setPrintValue($data)
    {
        return $this->setData('print_value', $data);
    }

    /**
     * @return string|null
     */
    public function getValueDefaultTitle()
    {
        return $this->getData('value_default_title');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setValueDefaultTitle($data)
    {
        return $this->setData('value_default_title', $data);
    }

    /**
     * @return string|null
     */
    public function getOptionId()
    {
        return $this->getData('option_id');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setOptionId($data)
    {
        return $this->setData('option_id', $data);
    }

    /**
     * @return string|null
     */
    public function getOptionType()
    {
        return $this->getData('option_type');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setOptionType($data)
    {
        return $this->setData('option_type', $data);
    }

    /**
     * @return string|null
     */
    public function getOptionValue()
    {
        return $this->getData('option_value');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setOptionValue($data)
    {
        return $this->setData('option_value', $data);
    }

    /**
     * @return string|null
     */
    public function getCustomView()
    {
        return $this->getData('custom_view');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setCustomView($data)
    {
        return $this->setData('custom_view', $data);
    }

    /**
     * @return string|null
     */
    public function getCode()
    {
        return $this->getData('code');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setCode($data)
    {
        return $this->setData('code', $data);
    }

    /**
     * @return string|null
     */
    public function getSku()
    {
        return $this->getData('sku');
    }

    /**
     * Set label
     *
     * @param string $data
     * @return $this
     */
    public function setSku($data)
    {
        return $this->setData('sku', $data);
    }

    /**
     * Retrieve existing extension attributes object or create a new one.
     *
     * @return ProductOptionExtensionInterface|null
     */
    public function getExtensionAttributes()
    {
        return $this->getData('extension_attributes');
    }

    /**
     * Set an extension attributes object.
     *
     * @param ProductOptionExtensionInterface $extensionAttributes
     * @return $this
     */
    public function setExtensionAttributes(
        ProductOptionExtensionInterface $extensionAttributes
    ) {
        return $this->setData('extension_attributes', $extensionAttributes);
    }
}
